module ExpressTemplates
  module Components
  end
end

# Abbreviation for your component class definitions
ET = ExpressTemplates

require 'express_templates/components/capabilities/iteration'
require 'express_templates/components/registry'
require 'express_templates/components/base'
require 'express_templates/components/configurable'
require 'express_templates/components/container'
require 'express_templates/components/tree_for'
require 'express_templates/components/content_for'
require 'express_templates/components/forms'
require 'express_templates/components/all'

module ExpressTemplates
  # Convienence classes for creating components in your app or engine
  class Component < Components::Base
    include Components::Capabilities::Configurable
    include Components::Capabilities::Hideable
    include Components::Capabilities::Suppressable
  end

  class Container < Components::Container
    include Components::Capabilities::Hideable
  end

  class ResourcefulContainer < Container
    include Components::Capabilities::Resourceful
  end

end