module ExpressTemplates
  module Components
    module Presenters
      class All < Container
        include Capabilities::Iteration

        has_argument :id, "Name of the collection", type: :symbol

        def start_tag; ''; end
        def end_tag; ''; end

        contains -> (&block) {
          prepended
          for_all(config[:id]) {
            block.call(self) if block
          }
          appended
        }

      end
    end
  end
end
