module ExpressTemplates
  module Components
    module Capabilities

      module Hideable

        def self.included(base)
          base.class_eval do

            has_option :hidden, "Toggles visiblity of the component. Assumes hidden CSS class.", type: :boolean, default: false

            before_build -> {
              add_class 'hidden' if config[:hidden]
            }

          end
        end
      end
    end
  end
end