# Proxy component for content_for to prevent it from inserting the block's
# value into its location.
class ContentForProxy < Arbre::HTML::Tag
  builder_method :content_for

  def build(key, content = nil, &block)
    @value = helpers.content_for(key, content, &block)
  end

  def to_s
    @value
  end
end

# Patch to #capture to support Arbre::Element
module ActionView
  module Helpers
    module CaptureHelper
      def capture(*args)
        value = nil
        buffer = with_output_buffer { value = yield(*args) }
        value = value.to_s if value.is_a?(Arbre::Element) || value.is_a?(Arbre::ElementCollection)
        if string = buffer.presence || value and string.is_a?(String)
          ERB::Util.html_escape string
        end
      end
    end
  end
end
